;
; MPFIT_PARAB
;
; Example of expression fit
;
!p.background = 'ffffff'xl
!p.color = '000000'xl

if n_elements(xx) EQ 0 then begin
   n = 20
   noise = 0.7
   xx = findgen(n)      ;; Equi-spaced X values
   yy = 1.2 + 0.07*xx^2  ;; Ideal parabola....   
   ys = yy + randomn(seed,n)*noise ;; ... with noise added
   ye = yy*0 + noise
endif
usersym, [-1,1], [0,0]

; =====================================
print, 'Fitting complete polynomial...'
expr = 'P[0] + X*P[1] + X^2*P[2]'
p = mpfitexpr(expr, xx, ys, ye, [1,1,1d], perror=dp, yfit=yfit)
plot, xx, ys, psym=8, charsize=1.7, $
      xtitle='X value', ytitle='Y value'
oplot, xx, yfit, thick=10, color='c0c0c0'xl
oplot, xx, yfit, linestyle=1
oploterror, xx, ys, ye, psym=8, hatlength=0

print, 'enter .CONTINUE to continue to next plot'
stop

; =====================================
print, 'Fitting constant plus quadratic...'
expr = 'P[0] + X^2*P[2]'
p = mpfitexpr(expr, xx, ys, ye, [1,1,1d], perror=dp, yfit=yfit)
plot, xx, ys, psym=8, charsize=1.7, $
      xtitle='X value', ytitle='Y value'
oplot, xx, yfit, thick=10, color='c0c0c0'xl
oplot, xx, yfit, linestyle=1
oploterror, xx, ys, ye, psym=8, hatlength=0

print, 'enter .CONTINUE to continue to next plot'
stop


end
