;
; MPFIT_LINFITEX
;
; Example of linear fit with errors in X and Y
;
!p.background = 'ffffff'xl
!p.color = '000000'xl

if n_elements(xs) EQ 0 then begin
   n = 20
   noise_x = 0.5 + randomn(seed,n)*0.2
   noise_y = 1.0 + randomn(seed,n)*0.2
   xx = findgen(n)      ;; Equi-spaced X values
   yy = 1.2 + 0.2*xx    ;; Ideal line

   xs = xx + randomn(seed,n)*noise_x ;; ... with noise added
   ys = yy + randomn(seed,n)*noise_y
   xe = yy*0 + noise_x
   ye = yy*0 + noise_y
endif
usersym, [-1,1], [0,0]

; =====================================
print, 'Fitting linear function ...'
p = mpfit('LINFITEX', [1d, 1d], $
             FUNCTARGS={X: XS, Y: YS, SIGMA_X: XE, SIGMA_Y: YE}, $
             perror=dp, bestnorm=chi2)
; Best fit line function
yfit = p[0] + p[1]*XS
plot, xs, ys, psym=3, charsize=1.7, $
      xtitle='X value', ytitle='Y value'
oploterror, xs, ys, xe, ye, psym=3, /nohat
print, 'enter .CONTINUE to overplot best fit'
stop

oplot, xs, yfit, thick=10, color='c0c0c0'xl
oplot, xs, yfit, linestyle=1
oploterror, xs, ys, xe, ye, psym=3, /nohat

print, 'enter .CONTINUE to continue to next plot'
stop

end
