;
; MPFIT_PARAB
;
; Example of parabola fit
;

!p.background = 'ffffff'xl
!p.color = '000000'xl

if n_elements(xx) EQ 0 then begin
   n = 20
   noise = 0.7
   xx = findgen(n)      ;; Equi-spaced X values
   yy = 1.2 + 0.07*xx^2  ;; Ideal parabola....   
   ys = yy + randomn(seed,n)*noise ;; ... with noise added
   ye = yy*0 + noise
endif
usersym, [-1,1], [0,0]

; =====================================
print, 'Plotting data and ideal fit...'
plot, xx, ys, psym=8, charsize=1.7, $
      xtitle='X value', ytitle='Y value'
oplot, xx, yy, thick=10, color='c0c0c0'xl
oplot, xx, yy, linestyle=1
oploterror, xx, ys, ye, psym=8, hatlength=0

print, 'enter .CONTINUE to continue to next plot'
stop


; =====================================
print, 'Plotting data and ideal fit with residuals...'
plot, xx, ys, psym=8, charsize=1.7, $
      xtitle='X value', ytitle='Y value'
oplot, xx, yy, thick=10, color='c0c0c0'xl
oplot, xx, yy, linestyle=1
oploterror, xx, ys, ye, psym=8, hatlength=0
oploterror, xx, (ys+yy)/2, (ys-yy)/2, psym=3, hatlength=0, $
            errcolor='ff'xl, thick=3

print, 'Chi-square value: ', total(((ys-yy)/(ye))^2)

print, 'enter .CONTINUE to continue to next plot'
stop

; =====================================
print, 'Plotting data and bad fit...'
ybad = 1.2 + 0.5*xx + 0.06*xx^2  ;; Badly fitting parabola....   

plot, xx, ys, psym=8, charsize=1.7, $
      xtitle='X value', ytitle='Y value'
oplot, xx, ybad, thick=10, color='c0c0c0'xl
oplot, xx, ybad, linestyle=1
oploterror, xx, ys, ye, psym=8, hatlength=0

print, 'enter .CONTINUE to continue to next plot'
stop


; =====================================
print, 'Plotting data and ideal fit with residuals...'
plot, xx, ys, psym=8, charsize=1.7, $
      xtitle='X value', ytitle='Y value'
oplot, xx, ybad, thick=10, color='c0c0c0'xl
oplot, xx, ybad, linestyle=1
oploterror, xx, ys, ye, psym=8, hatlength=0
oploterror, xx, (ys+ybad)/2, (ys-ybad)/2, psym=3, hatlength=0, $
            errcolor='ff'xl, thick=3

print, 'Chi-square value: ', total(((ys-ybad)/(ye))^2)

print, 'enter .CONTINUE to continue to next plot'
stop


end
